#include <stdio.h>
#include <stdlib.h>
#define InFile "firma.in"
#define OutFile "firma.out"
#define DMax 1001
#define Infinit 255
#define VMax 2000000000

//pentru fiecare imobil retin numarul de apartamente, precum si pretul chiriei pentru un apartament
typedef struct {char p, nr, nrmax;} imobil;
imobil a[DMax][DMax];
long int Sum[DMax][DMax];
int n, m;

void actualizare(int, int, long);
long venit(int, int, int, int);
long s(int , int);

int main()
{
int i, j, x, y, pret, nr, x1, y1, minx, miny, maxx, maxy, nrmax;
int tip;
long int v, total=0;
long int nro, p, k;

FILE *fin, *fout;
fin=fopen(InFile,"r"); fout=fopen(OutFile,"w");
fscanf(fin,"%d %d", &n, &m);
for (i=1; i<=n; i++)
    for (j=1; j<=m; j++)
        {a[i][j].nrmax=a[i][j].nr=-1; //=-1 daca in pozitia (x,y) nu exista imobil
         a[i][j].p=Infinit;
         Sum[i][j]=0;}
fscanf(fin,"%ld", &p);
for (k=1; k<=p; k++)
    {fscanf(fin, "%d %d %d %d %d", &x, &y, &nrmax, &nr, &pret);
     if (a[x][y].nr!=-1)
         printf("mai multe imobile in aceeasi pozitie\n");
     if (nr>nrmax) printf("prea multe apartamente inchiriate\n");
     a[x][y].nrmax=nrmax; a[x][y].nr=nr; a[x][y].p=pret;
     actualizare(x, y, (long int) nr*pret);
     total+=pret*nr;
     if (total >VMax || total<0) printf("venit prea mare\n");
     }
fscanf(fin, "%ld", &nro);
for (k=1; k<=nro; k++)
    {
    fscanf(fin,"%d", &tip);
    switch (tip)
    {
    case 1: //inchiriere apartament
           fscanf(fin,"%d %d",&x, &y);
           if (a[x][y].nr!=-1 && a[x][y].nr<a[x][y].nrmax) //in aceasta pozitie exista un imobil
              {a[x][y].nr++; actualizare(x, y, (long int )a[x][y].p);}
           total+=a[x][y].p;
           if (total > VMax) printf("venit prea mare\n");
           break;
    case 2: //eliberare apartament
            fscanf(fin,"%d %d", &x, &y);
            if (a[x][y].nr>0) //exista apartamente inchiriate?
               {a[x][y].nr--;  //eliberez un apartament
                actualizare(x, y, -(long int)a[x][y].p);
                total-=pret*nr;
               }
            break;
    case 3: //determinare venit
            fscanf(fin,"%d %d %d %d", &x1, &y1, &x, &y);
            minx=x1; maxx=x; if (x<x1) {minx=x; maxx=x1;}
            miny=y1; maxy=y; if (y<y1) {miny=y; maxy=y1;}
            v=venit(minx, miny, maxx, maxy);
            fprintf(fout,"%ld\n", v);
    }
    }
fclose(fin); fclose(fout);
return 0;
}

void actualizare (int x, int y, long val)
{
int nr0i=0, nr0j, i, j;
for (i=x; i<=n; i+=1<<nr0i)
    {for (j=y, nr0j=0;j<=m; j+=1<<nr0j)
        {
         Sum[i][j]+=val;
         if (Sum[i][j]>VMax || Sum[i][j]<0) printf("venit prea mare \n");
         while (!(j & 1<<nr0j)) nr0j++;
        }
    while (!(i & 1<<nr0i)) nr0i++;
    }
}

long venit (int x1, int y1, int x2, int y2)
{
return s(x2,y2)-s(x2,y1-1)-s(x1-1,y2)+s(x1-1,y1-1);
}

long s (int x, int y)
{
long val=0;
int nr0i=0, nr0j, i, j;
for (i=x; i>0; i-=1<<nr0i, nr0i++)
    {for (j=y, nr0j=0;j>0; j-=1<<nr0j, nr0j++)
        {
         val+=Sum[i][j];
         while (!(j & 1<<nr0j)) nr0j++;
        }
    while (!(i & 1<<nr0i)) nr0i++;
    }
if (val<0 || val > VMax) printf("venit prea mare\n");
return val;
}
